<?php
include( 'inc/template.php' );

if ($_SESSION['Role'] == 'Doctor') {
    $DoctorID = $UserId;
} else {
    $DoctorID = isset($DoctorID) ? $DoctorID : null; 
}
?>

    <style>
        .slot {
            display: inline-block;
            padding: 10px;
            margin: 5px;
            border: 1px solid #ccc;
            border-radius: 4px;
            cursor: pointer;
        }
        .slot.available { background-color: #d4edda; }
        .slot.booked { background-color: #f8d7da; cursor: not-allowed; }
        .slot.selected { background-color: #c3e6cb; border: 2px solid green; }
    </style>

    <div class="container-fluid flex-grow-1 container-p-y">
		<h4 class="py-0 mb-2"><span class="text-muted fw-light"><?php echo isset($_GET['id']) ? 'Update Appointment' : 'Add New Appointment'; ?></span></h4>
		<button type="button" class="btn btn-sm btn-primary" onclick="window.location.href='appointment_list.php';">
    <span class="ti-xs ti ti-chevron-left me-1"></span> Back to List
</button>
       <div class="card mb-4">
<!--<script type="text/javascript" src="ckeditor/ckeditor.js"></script>-->
			<form class="card-body" method="post" enctype="multipart/form-data">
            <div class="row g-3">
      <input type="hidden" name="doctor_id" id="doctor_id" value="<?php echo ($_SESSION['Role'] == 'Doctor') ? $UserId : $DoctorID; ?>" />
        <div class="col-md-12">
                <label for="patient_id" class="form-label">Patient Name</label>
               <input type="hidden" id="patient_id" name="patient_id">
               <input type="text" id="patient_name" name="patient_name" class="form-control" readonly>
            </div>
            <div class="col-md-12" id="appointment_details" style="display: none;">
        <div id="appointment_info" style="color:red"></div>
        </div>
            <div class="col-md-12 mb-2">
                <label for="is_paid" class="form-label">Is Paid</label>
                <select id="IsPaid" name="IsPaid" class="form-select">
                    <option value="0">No</option>
                    <option value="1">Yes</option>
                </select>
            </div>
            
            <div class="col-md-12 mb-2">
                <label for="TransactionID" class="form-label">Transaction ID</label>
                <input type="text" name="TransactionID" id="TransactionID" class="form-control" />
            </div>
                 <div class="col-md-12 mb-2">
                <label for="status" class="form-label">Status</label>
                <select id="Status" name="Status" class="form-select">
                    <option value="Not Visited">Not Visited</option>
                <option value="Visited">Visited</option>
              <option value="Cancelled">Cancelled</option>
            <option value="Rescheduled">Rescheduled</option>
                </select>
            </div>
            </div>
            <div class="row g-3" id="IsStatusGroupDiv">
            <div class="col-md-12 mb-2">
                <label for="appointment_date" class="form-label">Appointment Date</label>
                <input type="date" id="appointment_date" name="appointment_date" class="form-control" required min="<?php echo date('Y-m-d'); ?>">
            </div>

            <div class="col-md-12 mb-2">
                <label for="shift_time" class="form-label">Appointment Time</label>
                <select id="shift_time" name="shift_time" class="form-select">
                    <option value="">select</option>
                    <option value="Yes">Yes</option>
                </select>
                <!--<input type="text" id="shift_time" class="form-control" disabled>-->
            </div>

            <div class="col-md-12 mb-2">
                <label for="time_slot" class="form-label">Select a Slot</label>
                <div id="time_slots">
                    <!-- Dynamically populated time slots -->
                </div>
                <input type="hidden" id="selected_slot" name="selected_slot" required>
            </div>

            

           

            </div>
    <div class="pt-4">
        <input type="hidden" name="useridnew" id="useridnew" value="<?php echo $UserId; ?>" />
        <input type="hidden" id="rolenew" name="rolenew" value="<?php echo $Role; ?>">
        <input type="hidden" id="upd" value="<?php echo isset($_GET['id']) ? $_GET['id'] : ''; ?>">
        <input type="hidden" name="id" id="id">
        <input type="hidden" name="action" id="action" value="<?php echo isset($_GET['id']) ? 'Update' : 'Create'; ?>">
        <button type="submit" class="btn btn-primary me-2"><?php echo isset($_GET['id']) ? 'Update' : 'Save'; ?></button>
        <button type="reset" class="btn btn-label-secondary">Cancel</button>
    </div>
        </form>
    </div>
 </div>
 
 <script>
$(document).ready(function () {
    $('#patient_id').on('change', function () {
        var patientId = $(this).val();
        if (patientId) {
            $.ajax({
                url: 'fetch_appointment_details.php',
                method: 'POST',
                data: { patient_id: patientId },
                success: function (data) {
                    if (data) {
                        $('#appointment_info').html(data);
                        $('#appointment_details').show();
                    } else {
                        $('#appointment_details').hide();
                    }
                },
                error: function () {
                    alert('Error fetching appointment details.');
                }
            });
        } else {
            $('#appointment_details').hide();
        }
    });
    // Initialize variables
    const doctorId = $('#doctor_id').val();
    const formSelector = 'form.card-body';
// Trigger fetching shifts when the date is changed
    $('#appointment_date').on('change', function () {
        const date = $(this).val();

        $('#shift_time').empty().append('<option value="">Select Shift</option>');
        $('#time_slots').empty();

        if (date) {
            fetchShifts(date, doctorId);
        }
    });

    // Fetch shifts from the server
    function fetchShifts(date, doctorId) {
        $.ajax({
            url: 'fetch_shifts.php',
            method: 'GET',
            data: { date, doctor_id: doctorId },
            cache: false, // Disable caching to ensure fresh data
            success: function (response) {
                const data = JSON.parse(response);

                if (data.shifts && data.shifts.length > 0) {
                    populateShiftDropdown(data.shifts);
                } else {
                    alert('No shifts available for the selected date.');
                }
            },
            error: function () {
                alert('Error fetching shifts.');
            }
        });
    }

    // Populate shift dropdown dynamically
    function populateShiftDropdown(shifts) {
        shifts.forEach(shift => {
            $('#shift_time').append(
                `<option value="${shift.shift_id}">${shift.shift_time}</option>`
            );
        });
    }

    // Delegate event for shift change
    $(document).on('change', '#shift_time', function () {
        const selectedShiftId = $(this).val();
        const date = $('#appointment_date').val();

        if (selectedShiftId) {
            fetchBookingSlots(date, doctorId, selectedShiftId);
        } else {
            $('#time_slots').empty();
        }
    });

    // Fetch booking slots dynamically
    function fetchBookingSlots(date, doctorId, shiftId) {
        $.ajax({
            url: 'fetchbooking_slot.php',
            method: 'GET',
            data: { date, doctor_id: doctorId, shift_id: shiftId },
            cache: false, // Disable caching to ensure fresh data
            success: function (response) {
                const data = JSON.parse(response);

                $('#time_slots').empty();

                if (data.slots && data.slots.length > 0) {
                    populateTimeSlots(data.slots);
                } else {
                    alert('No slots available for the selected shift.');
                }
            },
            error: function () {
                alert('Error fetching booking slots.');
            }
        });
    }

    // Populate time slots dynamically
    function populateTimeSlots(slots) {
        slots.forEach(slot => {
            const slotClass = slot.isBooked ? 'slot booked' : 'slot available';
            const slotDisabled = slot.isBooked ? 'disabled' : '';

            $('#time_slots').append(
                `<div class="${slotClass}" data-slot="${slot.time}" ${slotDisabled}>${slot.time}</div>`
            );
        });

        // Handle slot selection
        $('.slot.available').on('click', function () {
            $('.slot').removeClass('selected');
            $(this).addClass('selected');
            $('#selected_slot').val($(this).data('slot'));
        });
    }

    // Optional: Auto-refresh slots periodically
    setInterval(() => {
        const date = $('#appointment_date').val();
        const shiftId = $('#shift_time').val();
        if (date && shiftId) {
            fetchBookingSlots(date, doctorId, shiftId);
        }
    }, 60000); // Refresh every 60 seconds



    // Handle form submission
    $(formSelector).on('submit', function (event) {
        event.preventDefault();

        const formData = {
            DoctorID: $('#doctor_id').val(),
            PatientID: $('#patient_id').val(),
            Date: $('#appointment_date').val(),
            Time: $('#selected_slot').val(),
            ShiftNumber: $('#shift_time').val(),
            IsPaid: $('#IsPaid').val(),
            TransactionID: $('#TransactionID').val(),
            Status: $('#Status').val(),
            id: $('#id').val(),
            useridnew: $('#useridnew').val(),
            rolenew: $('#rolenew').val(),
            action: $('#action').val(),
        };

        if (!formData.DoctorID || !formData.PatientID) {
            toastr.error('All required fields must be filled.');
            return;
        }

        submitForm(formData);
    });

    // Submit the form via AJAX
    function submitForm(formData) {
        $.ajax({
            url: 'appointment_action.php',
            method: 'POST',
            data: formData,
            success: function (response) {
                handleFormResponse(response);
            },
            error: function (xhr) {
                toastr.error('An error occurred while submitting the form.');
                console.error('AJAX error:', xhr.responseText);
            }
        });
    }

    // Handle the response from the server
    function handleFormResponse(response) {
        try {
            const res = typeof response === 'string' ? JSON.parse(response) : response;

            if (res.status === 'Rescheduled') {
                toastr.success('Appointment Rescheduled successfully.');
                setTimeout(() => window.location.href = 'appointment_list.php', 1500);
            } else if (res.status === 'Update') {
                toastr.success('Appointment updated successfully.');
                setTimeout(() => window.location.href = 'appointment_list.php', 1500);
            } else if (res.status === 'Duplicate') {
                toastr.error('Duplicate entry: PatientID already exists.');
            } else {
                toastr.error('Error: ' + (res.message || 'Unknown error occurred.'));
            }
        } catch (e) {
            toastr.error('Error parsing server response.');
            console.error('Parsing error:', e, 'Response:', response);
        }
    }

    // Load form data for updating if `upd` parameter exists
    const upd = $('#upd').val();
    if (upd) {
        fetchAppointmentData(upd);
    }

    // Fetch existing appointment data for update
    function fetchAppointmentData(upd) {
        $.ajax({
            url: 'appointment_action.php',
            method: 'POST',
            data: { id: upd, action: 'Select' },
            dataType: 'json',
            success: function (data) {
                populateFormData(data);
            },
            error: function () {
                toastr.error('Error fetching data for update.');
            }
        });
    }

    // Populate the form fields with existing data
    function populateFormData(data) {
        $('#doctor_id').val(data.DoctorID);
        $('#patient_id').val(data.PatientID).trigger('change');
        $('#patient_name').val(data.PatientName); 
        $('#appointment_date').val(data.Date);
        $('#IsPaid').val(data.IsPaid).trigger('change');
        $('#TransactionID').val(data.TransactionID);
        $('#Status').val(data.Status).trigger('change');
        $('#id').val(data.AppointmentID);
        $('#action').val('Update');

        const selectedTime = data.Time;
        const timeDropdown = $('#shift_time');

        if (timeDropdown.find(`option[value='${selectedTime}']`).length === 0) {
            timeDropdown.append(`<option value="${selectedTime}">${selectedTime}</option>`);
        }
        timeDropdown.val(selectedTime);
    }

    // Toggle TransactionID visibility based on IsPaid value
    $('#IsPaid').on('change', function () {
        if ($(this).val() === '1') {
            $('#TransactionID').attr('required', true).parent().show();
        } else {
            $('#TransactionID').removeAttr('required').parent().hide();
        }
    }).trigger('change');
    
    $("#Status").change(function () {
            if ($(this).val() == "Rescheduled") {
                $('#IsStatusGroupDiv').show();
                $('#appointment_date').attr('required', '');
                $('#appointment_date').attr('data-error', 'This field is required.');
                $('#shift_time').attr('required', '');
                $('#shift_time').attr('data-error', 'This field is required.');
                $('#selected_slot').attr('required', '');
                $('#selected_slot').attr('data-error', 'This field is required.');
               
            } else {
                $('#IsStatusGroupDiv').hide();
                $('#appointment_date').removeAttr('required');
                $('#appointment_date').removeAttr('data-error');
                $('#shift_time').removeAttr('required');
                $('#shift_time').removeAttr('data-error');
                $('#selected_slot').removeAttr('required');
                $('#selected_slot').removeAttr('data-error');
                
            }
        });
    $("#Status").trigger("change");
	
});
</script>
<script src="assets/js/form-wizard-numbered.js"></script>
    <script src="assets/js/form-wizard-validation.js"></script>

<?php include('inc/footer.php');?>
	<?php//}?>
