<?php
// Fetch booked appointment times
if ($_SESSION['Role'] == 'Doctor') {
    $result = $conn->query("SELECT DoctorID, Date, Time FROM Appointments WHERE DoctorID = '$UserId' AND Status != 'Cancelled'");
    } else { 
    $result = $conn->query("SELECT DoctorID, Date, Time FROM Appointments WHERE DoctorID = '$DoctorID' AND Status != 'Cancelled'");
    }
$bookedschedules = [];
while ($row = $result->fetch_assoc()) {
    $bookedschedules[] = $row;
}

// Fetch doctor schedules
if ($_SESSION['Role'] == 'Doctor') {
    $result = $conn->query("SELECT DoctorID, DayOfWeek, ShiftNumber, StartTime, EndTime, AppointmentInterval FROM Doctorschedules WHERE DoctorID = '$UserId' ORDER BY DayOfWeek ASC");
    } else { 
    $result = $conn->query("SELECT DoctorID, DayOfWeek, ShiftNumber, StartTime, EndTime, AppointmentInterval FROM Doctorschedules WHERE DoctorID = '$DoctorID' ORDER BY DayOfWeek ASC");
    }
$schedules = [];
while ($row = $result->fetch_assoc()) {
    $schedules[] = $row;
}
?>
<script>
  // Map numeric days (0-6) to string days
const dayMapping = ["Sunday", "Monday", "Tuesday", "Wednesday", "Thursday", "Friday", "Saturday"];

// Data from PHP
const schedules = <?php echo json_encode($schedules); ?>;
const bookedSchedules = <?php echo json_encode($bookedschedules); ?>;

function populateTimeSlots() {
    const currentDay = dayMapping[new Date().getDay()]; // Get the current day as a string
    const timeDropdown = document.getElementById("Time");
    timeDropdown.innerHTML = '<option value="">Select a time slot</option>'; // Reset options

    const now = new Date(); // Current date and time

    schedules.forEach((schedule) => {
        if (schedule.DayOfWeek === currentDay) {
            const startTime = new Date(`1970-01-01T${schedule.StartTime}`);
            const endTime = new Date(`1970-01-01T${schedule.EndTime}`);
            const interval = parseInt(schedule.AppointmentInterval);

            let currentTime = startTime;
            while (currentTime < endTime) {
                const timeString = currentTime.toTimeString().slice(0, 5); // Format as HH:mm
                
                // Check if the time slot is in the past
                const todaySlotTime = new Date(
                    now.getFullYear(),
                    now.getMonth(),
                    now.getDate(),
                    currentTime.getHours(),
                    currentTime.getMinutes()
                );
                
                if (todaySlotTime >= now) { // Only add future or current time slots
                    const option = document.createElement("option");
                    option.value = timeString;
                    option.textContent = timeString;

                    // Check if this time slot is booked
                    const isBooked = bookedSchedules.some(
                    (booked) =>
                    booked.DoctorID === schedule.DoctorID &&
                    booked.Date === `${now.getFullYear()}-${(now.getMonth() + 1).toString().padStart(2, '0')}-${now.getDate().toString().padStart(2, '0')}` &&
                    booked.Time.slice(0, 5) === timeString // Normalize to HH:mm
                    );


                    if (isBooked) {
                        option.disabled = true; // Disable the option
                        option.style.color = "red"; // Set a different color for booked slots
                        option.textContent += " (Booked)"; // Add label for booked slots
                    }

                    timeDropdown.appendChild(option);
                }

                currentTime = new Date(currentTime.getTime() + interval * 60000); // Increment by interval
            }
        }
    });
    
    if (selectedTime) {
        timeDropdown.value = selectedTime;
    }
}

// Call the function on page load
window.onload = populateTimeSlots;
</script>