<?php
error_reporting(E_ALL);
ini_set('display_errors', 1);

date_default_timezone_set("Asia/Calcutta");

$fromdate = date('Y-m-d H:i:s');

// Include database configuration file
include('inc/config.php');

if ($_SERVER['REQUEST_METHOD'] === 'POST') {
    $action = $_POST['action'];
    $id = $_POST['id'] ?? null;

    // Sanitize input
   
    $FirstName = mysqli_real_escape_string($conn, $_POST['FirstName'] ?? '');
    $LastName = mysqli_real_escape_string($conn, $_POST['LastName'] ?? '');
    $Email = mysqli_real_escape_string($conn, $_POST['Email'] ?? '');
    $Phone = mysqli_real_escape_string($conn, $_POST['Phone'] ?? '');
    $Username = mysqli_real_escape_string($conn, $_POST['Username'] ?? '');
    $Address = mysqli_real_escape_string($conn, $_POST['Address'] ?? '');
    $JobTitle = mysqli_real_escape_string($conn, $_POST['JobTitle'] ?? '');
    

    // Action handling
    if ($action === 'Update' && $id) {
        // Check for duplicates excluding current record
        $checkDuplicate = "SELECT * FROM Employees WHERE (Email = '$Email' OR Phone = '$Phone' OR Username = '$Username') AND EmployeeID != '$id'";
        $duplicateResult = mysqli_query($conn, $checkDuplicate);

        if (mysqli_num_rows($duplicateResult) > 0) {
            echo json_encode(['status' => 'Error', 'message' => 'Duplicate record found']);
        } else {
            // Update record
            $updateQuery = "UPDATE Employees SET 
                            FirstName = '$FirstName', LastName = '$LastName', Email = '$Email', Phone = '$Phone', Username = '$Username', Address = '$Address', JobTitle = '$JobTitle', UpdatedAt = '$fromdate'
                            WHERE EmployeeID = '$id'";
            if (mysqli_query($conn, $updateQuery)) {
                echo json_encode(['status' => 'Update']);
            } else {
                echo json_encode(['status' => 'Error', 'message' => mysqli_error($conn)]);
            }
        }
    } elseif ($action === 'Select' && $id) {
        // Fetch a record
        $query = "SELECT * FROM Employees WHERE EmployeeID = '$id'";
        $result = mysqli_query($conn, $query);

        if ($result && mysqli_num_rows($result) > 0) {
            $row = mysqli_fetch_assoc($result);
            echo json_encode($row);
        } else {
            echo json_encode(['status' => 'Error', 'message' => 'Record not found']);
        }
    } 
    
}

// Close database connection
mysqli_close($conn);
?>
