<?php
include 'inc/config.php';

error_reporting(E_ALL);
ini_set('display_errors', 1);

if ($_SERVER['REQUEST_METHOD'] === 'POST' && isset($_POST['patient_id'])) {
    $patientId = intval($_POST['patient_id']);
    $stmt = $conn->prepare("
        SELECT Date, Time 
        FROM Appointments 
        WHERE PatientID = ? 
        AND (Status != 'Cancelled' AND Status != 'Rescheduled' AND Status != 'Visited') 
        ORDER BY Date DESC,Time DESC LIMIT 1
    ");
    $stmt->bind_param("i", $patientId);
    $stmt->execute();
    $result = $stmt->get_result();

   if ($row = $result->fetch_assoc()) {
        echo "Your appointment date " . htmlspecialchars(date('d-m-Y', strtotime($row['Date']))) . 
             " and time " . htmlspecialchars(date('h:i A', strtotime($row['Time']))) . " is already booked.";
    } else {
        echo ""; // No appointment found
    }
    $stmt->close();
}
?>
