<?php
include('inc/config.php');
date_default_timezone_set('Asia/Kolkata');

if (isset($_GET['date']) && isset($_GET['doctor_id'])) {
    $date = $_GET['date'];
    $doctorId = $_GET['doctor_id'];
    $dayOfWeek = ucfirst(strtolower(date('l', strtotime($date))));
    $currentTime = time(); // Current timestamp
    $isToday = (date('Y-m-d') === $date); // Check if the selected date is today

    $query = "
        SELECT ShiftNumber, StartTime, EndTime, AppointmentInterval
        FROM Doctorschedules
        WHERE DoctorID = '$doctorId' 
        AND TRIM(UPPER(DayOfWeek)) = TRIM(UPPER('$dayOfWeek'))
    ";

    $result = $conn->query($query);
    $shifts = [];

    if ($result && $result->num_rows > 0) {
        while ($row = $result->fetch_assoc()) {
            $shiftStartTime = strtotime($row['StartTime']);
            $shiftEndTime = strtotime($row['EndTime']);

            // Only exclude shifts for today if they have ended
            if (!$isToday || $shiftEndTime > $currentTime) {
                $shifts[] = [
                    'shift_id' => $row['ShiftNumber'],
                    'shift_time' => date('h:i A', $shiftStartTime) . ' - ' . date('h:i A', $shiftEndTime),
                ];
            }
        }
    }

    echo json_encode(['shifts' => $shifts]);
} else {
    echo json_encode(['error' => 'Missing date or doctor_id']);
}
?>
