<?php
include('inc/config.php');

if (isset($_GET['shift']) && isset($_GET['date']) && isset($_GET['doctor_id'])) {
    $shift = $_GET['shift'];
    $date = $_GET['date'];
    $doctorId = $_GET['doctor_id'];

    // Fetch schedule for the shift
    $stmt = $conn->prepare("
        SELECT StartTime, EndTime, AppointmentInterval 
        FROM Doctorschedules 
        WHERE DoctorID = ? AND ShiftNumber = ? AND DayOfWeek = ?
    ");
    $dayOfWeek = date('l', strtotime($date));
    $stmt->bind_param("iis", $doctorId, $shift, $dayOfWeek);
    $stmt->execute();
    $schedule = $stmt->get_result()->fetch_assoc();

    if ($schedule) {
        $startTime = strtotime($schedule['StartTime']);
        $endTime = strtotime($schedule['EndTime']);
        $interval = $schedule['AppointmentInterval'];

        // Fetch already booked slots
        $bookedSlots = [];
        $stmt = $conn->prepare("
            SELECT AppointmentTime 
            FROM Appointments 
            WHERE DoctorID = ? AND AppointmentDate = ? AND Status = 'Confirmed'
        ");
        $stmt->bind_param("is", $doctorId, $date);
        $stmt->execute();
        $result = $stmt->get_result();
        while ($row = $result->fetch_assoc()) {
            $bookedSlots[] = $row['AppointmentTime'];
        }

        // Generate time slots
        while ($startTime < $endTime) {
            $timeSlot = date('H:i', $startTime);
            $class = in_array($timeSlot, $bookedSlots) ? 'slot booked' : 'slot available';
            echo "<button type='button' class='$class' data-time='$timeSlot'>$timeSlot</button>";
            $startTime = strtotime("+$interval minutes", $startTime);
        }
    } else {
        echo "<div>No time slots available for this shift.</div>";
    }
}
?>
