<?php
include('inc/config.php');
date_default_timezone_set('Asia/Kolkata');

// Debugging output
error_reporting(E_ALL);
ini_set('display_errors', 1);

if (isset($_GET['date'], $_GET['doctor_id'], $_GET['shift_id'])) {
    $date = $_GET['date'];
    $doctorId = $_GET['doctor_id'];
    $shiftId = $_GET['shift_id'];

    $currentDateTime = time(); // Current timestamp in India

    $query = "
        SELECT StartTime, EndTime, AppointmentInterval 
        FROM Doctorschedules 
        WHERE DoctorID = '$doctorId' AND ShiftNumber = '$shiftId'
    ";
    $result = $conn->query($query);

    if ($result && $row = $result->fetch_assoc()) {
        $startTime = strtotime($row['StartTime']);
        $endTime = strtotime($row['EndTime']);
        $interval = $row['AppointmentInterval'];

        $slots = [];
        while ($startTime < $endTime) {
            $timeSlot = date('h:i A', $startTime);

            // Skip past time slots for today's date
            if ($date === date('Y-m-d') && $startTime <= $currentDateTime) {
                $startTime = strtotime("+$interval minutes", $startTime);
                continue;
            }

            $isBookedQuery = "
                SELECT COUNT(*) as count 
                FROM Appointments 
                WHERE DoctorID = '$doctorId' AND Date = '$date' AND Time = '$timeSlot' AND (Status != 'Cancelled' AND Status != 'Rescheduled')
            ";
            $isBookedResult = $conn->query($isBookedQuery);

            if (!$isBookedResult) {
                die("Booking query failed: " . $conn->error);
            }

            $isBookedRow = $isBookedResult->fetch_assoc();
            $slots[] = [
                'time' => $timeSlot,
                'isBooked' => $isBookedRow['count'] > 0
            ];

            $startTime = strtotime("+$interval minutes", $startTime);
        }

        echo json_encode(['slots' => $slots]);
    } else {
        die("Shift query failed: " . $conn->error);
    }
} else {
    die("Required parameters are missing.");
}
?>
