<?php
include 'inc/config.php'; 

if (isset($_POST['patient_id'])) {
    $patient_id = $_POST['patient_id'];

    // Query to get appointments for the selected patient
    $query = $conn->prepare("SELECT AppointmentID, Date, Time FROM Appointments WHERE PatientID = ? AND (Status != 'Cancelled' AND Status != 'Rescheduled') ORDER BY Date ASC");
    $query->bind_param("i", $patient_id);
    $query->execute();
    $result = $query->get_result();

    // Initialize an empty array to store appointments
    $appointments = [];
    while ($row = $result->fetch_assoc()) {
        // Format the Date to dd-mm-yyyy
        $formattedDate = date("d-m-Y", strtotime($row['Date']));

        // Format the Time to 12-hour format with AM/PM
        $formattedTime = date("g:i A", strtotime($row['Time']));

        // Add the formatted values to the appointments array
        $appointments[] = [
            'id' => $row['AppointmentID'],
            'date' => $formattedDate,
            'time' => $formattedTime,
        ];
    }

    // Return the appointments as a JSON response
    echo json_encode($appointments);
}
?>
