<?php
error_reporting(0);
ini_set('display_errors', 1);
session_start();

// Retrieve session variables
$Role = isset($_SESSION['Role']) ? $_SESSION['Role'] : null;
$UserId = isset($_SESSION['UserId']) ? $_SESSION['UserId'] : null;
$Login_name = isset($_SESSION['Login_name']) ? $_SESSION['Login_name'] : null;

// Include configuration file
include('inc/config.php');

// Set timezone
date_default_timezone_set("Asia/Calcutta"); // India time (GMT+5:30)
$fromdate = date('Y-m-d H:i:s');

// Redirect to login page if Role is not Admin or UserId is missing
if (empty($UserId) || empty($Role) || $Role !== 'Admin' || empty($Login_name)) {
    echo "
    <script>
        alert('Please log in first.');
        window.location.href = 'index.php';
    </script>
    ";
    exit(); // Stop further script execution
}
?>






<!DOCTYPE html>

<html lang="en" class="light-style layout-menu-fixed layout-compact" dir="ltr" data-theme="theme-default" data-assets-path="assets/" data-template="horizontal-menu-template">
<head>
	<meta charset="utf-8"/>
	<meta name="viewport" content="width=device-width, initial-scale=1.0, user-scalable=no, minimum-scale=1.0, maximum-scale=1.0"/>

	<?php include('inc/meta-tag.php');?>

	<meta name="description" content=""/>
	<!--<link rel="apple-touch-icon" sizes="180x180" href="assets/img/favicon/apple-touch-icon.png">-->
	<!--<link rel="icon" type="image/png" sizes="32x32" href="assets/img/favicon/favicon-32x32.png">-->
	<!--<link rel="icon" type="image/png" sizes="16x16" href="assets/img/favicon/favicon-16x16.png">-->
	<!--<link rel="manifest" href="assets/img/favicon/site.webmanifest">-->

	<!-- Icons -->
	<link rel="stylesheet" href="assets/vendor/fonts/fontawesome.css"/>
	<link rel="stylesheet" href="assets/vendor/fonts/tabler-icons.css"/>
	<link rel="stylesheet" href="assets/vendor/fonts/flag-icons.css"/>

	<!-- Core CSS -->
	<link rel="stylesheet" href="assets/vendor/css/rtl/core.css"/>
	<link rel="stylesheet" href="assets/vendor/css/rtl/theme-default.css"/>


	<!-- Vendors CSS -->
	<link rel="stylesheet" href="assets/vendor/libs/node-waves/node-waves.css"/>
	<link rel="stylesheet" href="assets/vendor/libs/perfect-scrollbar/perfect-scrollbar.css"/>
	<link rel="stylesheet" href="assets/vendor/libs/typeahead-js/typeahead.css"/>
	<link rel="stylesheet" href="assets/vendor/libs/bootstrap-select/bootstrap-select.css"/>
	<link rel="stylesheet" href="assets/vendor/libs/select2/select2.css"/>
	<link rel="stylesheet" href="assets/vendor/libs/flatpickr/flatpickr.css"/>
	<link rel="stylesheet" href="assets/vendor/libs/typeahead-js/typeahead.css"/>
	<link rel="stylesheet" href="assets/vendor/libs/tagify/tagify.css"/>

	<link rel="stylesheet" href="assets/vendor/libs/datatables-bs5/datatables.bootstrap5.css"/>
	<link rel="stylesheet" href="assets/vendor/libs/datatables-responsive-bs5/responsive.bootstrap5.css"/>
	<link rel="stylesheet" href="assets/vendor/libs/datatables-buttons-bs5/buttons.bootstrap5.css"/>
	<link rel="stylesheet" href="assets/vendor/libs/flatpickr/flatpickr.css"/>
	
	<!-- Helpers -->
	<script src="assets/vendor/js/helpers.js"></script>

	<script src="assets/js/config.js"></script>
     <script src="assets/js/jquery.min.js"></script>
<link rel="stylesheet" href="assets/toastr.min.css">
<script src="assets/toastr.min.js"></script>


</head>

<body>
	<!-- Layout wrapper -->
	<div class="layout-wrapper layout-navbar-full layout-horizontal layout-without-menu">
		<div class="layout-container">
			<!-- Navbar -->

			<nav class="layout-navbar navbar navbar-expand-xl align-items-center bg-navbar-theme" id="layout-navbar">
				<div class="container-xxl">
					<div class="navbar-brand app-brand demo d-none d-xl-flex py-0 me-4"> <a href="dashboard.php" class="app-brand-link gap-2"> <img src="assets/img/logo.png" width="150" alt="">
            </a>
						<a href="javascript:void(0);" class="layout-menu-toggle menu-link text-large ms-auto d-xl-none"> <i class="ti ti-x ti-sm align-middle"></i> </a> </div>
					<div class="layout-menu-toggle navbar-nav align-items-xl-center me-3 me-xl-0 d-xl-none"> <a class="nav-item nav-link px-0 me-xl-4" href="javascript:void(0)"> <i class="ti ti-menu-2 ti-sm"></i> </a> </div>
					<div class="navbar-nav-right d-flex align-items-center" id="navbar-collapse">
						<ul class="navbar-nav flex-row align-items-center ms-auto">



							<!-- User -->
							<li class="nav-item navbar-dropdown dropdown-user dropdown">
								<a class="nav-link dropdown-toggle hide-arrow" href="javascript:void(0);" data-bs-toggle="dropdown">
									<div class="avatar avatar-online">
										<span class="btn rounded-pill btn-icon btn-primary waves-effect waves-light" style="font-size: 18px">
											<?php echo strtoupper(substr($Login_name, 0, 1)); 
 ?>
										</span>
									</div>
								</a>
								<ul class="dropdown-menu dropdown-menu-end">
									<li>
										<a class="dropdown-item" href="#">
											<div class="d-flex">
												<div class="flex-shrink-0 me-3">
													<div class="avatar avatar-online">
														<span class="btn rounded-pill btn-icon btn-primary waves-effect waves-light">
															<?php echo substr($Login_name, 0, 1); ?>
														</span>
													</div>
												</div>
												<div class="flex-grow-1">
													<span class="fw-medium d-block">
														<?php echo substr($Login_name, 0, 15);
 ?>
													</span>
													<small class="text-muted">
														<?php echo $Role; ?>
													</small>
												</div>
											</div>
										</a>
									</li>
									<li>
										<div class="dropdown-divider"></div>
									</li>
									<li> <a class="dropdown-item" href="change_password.php"> <i class="ti ti-password me-2 ti-sm"></i> <span class="align-middle">Change Password</span> </a> </li>
									<li> <a class="dropdown-item" href="logout.php"> <i class="ti ti-logout me-2 ti-sm"></i> <span class="align-middle">logout</span> </a> </li>

								</ul>
							</li>
							<!--/ User -->
						</ul>
					</div>

					<!-- Search Small Screens -->
					<!--<div class="navbar-search-wrapper search-input-wrapper container-xxl d-none">-->
					<!--	<input type="text" class="form-control search-input border-0" placeholder="Search..." aria-label="Search..."/>-->
					<!--	<i class="ti ti-x ti-sm search-toggler cursor-pointer"></i> </div>-->
				</div>
			</nav>

			<!-- Layout container -->
			<div class="layout-page">
				<!-- Content wrapper -->
				<div class="content-wrapper">
					<!-- Menu -->
					<?php include('inc/header_menu.php');?>
					<?php //main(); ?>
					
				