<?php
error_reporting(0);
include('inc/config.php');
?>
<!DOCTYPE html>

<html lang="en" class="light-style layout-wide customizer-hide" dir="ltr" data-theme="theme-default" data-assets-path="assets/" data-template="horizontal-menu-template">
<head>
	<meta charset="utf-8"/>
	<meta name="viewport" content="width=device-width, initial-scale=1.0, user-scalable=no, minimum-scale=1.0, maximum-scale=1.0"/>

	<title>Login </title>


	<meta name="description" content=""/>

	<link rel="apple-touch-icon" sizes="180x180" href="assets/img/favicon/apple-touch-icon.png">
	<link rel="icon" type="image/png" sizes="32x32" href="assets/img/favicon/favicon-32x32.png">
	<link rel="icon" type="image/png" sizes="16x16" href="assets/img/favicon/favicon-16x16.png">
	<link rel="manifest" href="assets/img/favicon/site.webmanifest">


	<!-- Icons -->
	<link rel="stylesheet" href="assets/vendor/fonts/fontawesome.css"/>
	<link rel="stylesheet" href="assets/vendor/fonts/tabler-icons.css"/>
	<link rel="stylesheet" href="assets/vendor/fonts/flag-icons.css"/>

	<!-- Core CSS -->
	<link rel="stylesheet" href="assets/vendor/css/rtl/core.css" class="template-customizer-core-css"/>
	<link rel="stylesheet" href="assets/vendor/css/rtl/theme-default.css" class="template-customizer-theme-css"/>
	<link rel="stylesheet" href="assets/css/demo.css"/>

	<!-- Vendors CSS -->
	<link rel="stylesheet" href="assets/vendor/libs/node-waves/node-waves.css"/>
	<link rel="stylesheet" href="assets/vendor/libs/perfect-scrollbar/perfect-scrollbar.css"/>
	<link rel="stylesheet" href="assets/vendor/libs/typeahead-js/typeahead.css"/>
	<!-- Vendor -->


	<!-- Page CSS -->
	<!-- Page -->
	<link rel="stylesheet" href="assets/vendor/css/pages/page-auth.css"/>

	<!-- Helpers -->
	<script src="assets/vendor/js/helpers.js"></script>
	
	<script src="assets/js/config.js"></script>
	<script src="assets/js/jquery.min.js"></script>
	<link rel="stylesheet" href="assets/toastr.min.css">
	<script src="assets/toastr.min.js"></script>
</head>

<body>
	
<?php
if ($_SERVER["REQUEST_METHOD"] === "POST") {
    // Sanitize and validate inputs
    $username = filter_input(INPUT_POST, 'username', FILTER_SANITIZE_STRING);
    $password = $_POST["password"];
    
    $captcha_response = $_POST["g-recaptcha-response"]; 

    $secret_key = '6LeNJaAqAAAAAC5etlvBB48ACJxu8rl9GPtOezTy';  

    // Verify reCAPTCHA
    $recaptcha_url = 'https://www.google.com/recaptcha/api/siteverify';
    $response = file_get_contents($recaptcha_url . '?secret=' . $secret_key . '&response=' . $captcha_response); 
    $responseKeys = json_decode($response, true);

    if (!isset($responseKeys['success']) || $responseKeys['success'] !== true) {
        // Log reCAPTCHA errors for debugging
        error_log("reCAPTCHA failed: " . json_encode($responseKeys));

        // Store error message in session for display
        session_start();
        $_SESSION['error_message'] = "reCAPTCHA verification failed. Please try again.";
        header("Location: " . $_SERVER['PHP_SELF']); // Redirect to the same page
        exit;
    }


    // Validate inputs
    if (empty($username) || empty($password)) {
        echo "<script>
            $(document).ready(function() {
                toastr.error('Username and password are required.');
            });
        </script>";
        exit;
    }

    try {
        // Use prepared statements to prevent SQL Injection
        $stmt = $conn->prepare("SELECT UserID, Username, PasswordHash, FullName, Role FROM Users WHERE Username = ? AND Status = '1'");
        $stmt->bind_param("s", $username);  // "s" indicates the username is a string

        $stmt->execute();
        $result = $stmt->get_result();

        // If the user is found
        if ($result && $result->num_rows > 0) {
            $row = $result->fetch_assoc();
            $userId = $row['UserID'];
            $fetchedUsername = $row['Username'];
            $hashedPassword = $row['PasswordHash'];
            $fetchedName = $row['FullName'];
            $role = $row['Role'];

            // Verify the password using password_verify
            if (password_verify($password, $hashedPassword)) {
                session_start();  // Start the session securely

                // Store user details in session
                $_SESSION["UserId"] = $userId;
                $_SESSION["Role"] = $role;
                $_SESSION["Login_name"] = $fetchedName;

                // Set cookies if "remember me" option is checked
                if (!empty($_POST["remember"])) {
                    setcookie("UserId", $userId, time() + (10 * 365 * 24 * 60 * 60), "/", "", true, true);  // Secure cookie
                    setcookie("Role", $role, time() + (10 * 365 * 24 * 60 * 60), "/", "", true, true);      // Secure cookie
                }

                // Redirect to dashboard
                echo "<script>
                    $(document).ready(function() {
                        toastr.success('Login Successful');
                    });
                    setTimeout(function(){
                        window.location.href = 'dashboard.php';
                    }, 1000);
                </script>";
            } else {
                // Invalid password
                echo "<script>
                    $(document).ready(function() {
                        toastr.error('Invalid username or password.');
                    });
                </script>";
            }
        } else {
            // Username not found
            echo "<script>
                $(document).ready(function() {
                    toastr.error('Username not found.');
                });
            </script>";
        }
    } catch (Exception $e) {
            error_log("Error during login: " . $e->getMessage());
            echo "<script>
                $(document).ready(function() {
                    toastr.error('An error occurred. Please try again later.');
                });
            </script>";
        } finally {
            mysqli_close($conn);
        }
    
}
?>

<?php
session_start();
if (isset($_SESSION['error_message'])) {
    echo "<script>
        $(document).ready(function() {
            toastr.error('" . $_SESSION['error_message'] . "');
        });
    </script>";
    unset($_SESSION['error_message']); 
}
?>



<div class="container-xxl">
      <div class="authentication-wrapper authentication-basic container-p-y">
        <div class="authentication-inner py-4">
          <!-- Login -->
          <div class="card">
            <div class="card-body">
              <!-- Logo -->
              <div class="app-brand justify-content-center mb-4 mt-2" >
                
                  <img src="assets/img/hyena_logo.png" width="300" >
                
              </div>
             
             
              <form  class="mb-3" action="#" method="POST">
                <div class="mb-3">
                  <label for="username" class="form-label">Username</label>
                  <input type="text" class="form-control" name="username" placeholder="Enter your username" value="<?php if(isset($_COOKIE["user_login"])) { echo $_COOKIE["user_login"]; } ?>" autofocus />
                </div>
                <div class="mb-3 form-password-toggle">
                  <div class="d-flex justify-content-between">
                    <label class="form-label" for="password">Password</label>

                    <a href="reset_password.php">
                      <small>Reset Password?</small>
                    </a>

                  </div>
                  <div class="input-group input-group-merge">
                    <input  type="password" class="form-control" name="password"  placeholder="&#xb7;&#xb7;&#xb7;&#xb7;&#xb7;&#xb7;&#xb7;&#xb7;&#xb7;&#xb7;&#xb7;&#xb7;"
                      aria-describedby="password" value="<?php if(isset($_COOKIE[" password "])) { echo $_COOKIE["password "]; } ?>" />
                    <span class="input-group-text cursor-pointer"><i class="ti ti-eye-off"></i></span>
                  </div>
                </div>
                <!-- Google reCAPTCHA Widget -->
  <div class="g-recaptcha" data-sitekey="6LeNJaAqAAAAAAAJKmjT_hTIRyrKVZeX-qmAAHMW"></div>
                <input class="form-check-input" type="checkbox" name="remember"  checked style="display: none" />
                   
                    
                <div class="mb-3">
					
                  <button class="btn btn-primary d-grid w-100" type="submit" name="login">Login</button>
                </div>
              </form>
<script src="https://www.google.com/recaptcha/api.js" async defer></script>

            </div>
          </div>
          <!-- /Register -->
        </div>
      </div>
    </div>
	
	<script src="assets/vendor/libs/jquery/jquery.js"></script>
	<script src="assets/vendor/libs/popper/popper.js"></script>
	<script src="assets/vendor/js/bootstrap.js"></script>
	<script src="assets/vendor/libs/node-waves/node-waves.js"></script>
	<script src="assets/vendor/libs/perfect-scrollbar/perfect-scrollbar.js"></script>
	<script src="assets/vendor/libs/hammer/hammer.js"></script>
	<script src="assets/vendor/libs/i18n/i18n.js"></script>
	<script src="assets/vendor/libs/typeahead-js/typeahead.js"></script>
	<script src="assets/vendor/js/menu.js"></script>
	<script src="assets/js/main.js"></script>
	<script src="assets/js/pages-auth.js"></script>
</body>
</html>