<?php
include( 'inc/template.php' );

// Function to handle main operations
//function main() {
//	global $conn;
$PrescriptionID = isset($_GET['id']) ? $_GET['id'] : null;
$result = mysqli_query( $conn, "SELECT p.PrescriptionID, p.DoctorID,p.Date, d.Name AS DoctorName, p.PatientID,pa.UniqueID, pa.Phone,pa.PatientName, p.AppointmentID, a.Date AS AppointmentDate, a.Time AS AppointmentTime, p.Medicine, p.Dosage, p.ReportsName, p.SpecialNote, p.Date AS PrescriptionDate FROM Prescriptions p JOIN Doctors d ON p.DoctorID = d.DoctorID JOIN Patients pa ON p.PatientID = pa.PatientID JOIN Appointments a ON p.AppointmentID = a.AppointmentID WHERE p.PrescriptionID = '$PrescriptionID'" );
$row = mysqli_fetch_array( $result );


?>

<div class="container-fluid flex-grow-1 container-p-y">
  <h4 class="py-0 mb-2"><span class="text-muted fw-light">Prescription Details</span></h4>
  <button type="button" class="btn btn-sm btn-primary" onclick="window.location.href='prescription_list.php';"> <span class="ti-xs ti ti-chevron-left me-1"></span> Back to List </button>
  
  <div class="row">
                <div class="col-xl-12 col-lg-5 col-md-5">
                  <!-- About User -->
                  <div class="card mb-4">
                    <div class="card-body">
                      
                      <ul class="list-unstyled mb-4 mt-3">
						  
                        <li class="d-flex align-items-center mb-3">
                          <i class="ti ti-calendar text-heading"></i
                          ><span class="fw-medium mx-2 text-heading">Date:</span> <span><?php echo htmlspecialchars(date('d-m-Y', strtotime($row['Date']))); ?>
</span>
                        </li>
                        <li class="d-flex align-items-center mb-3">
                          <i class="ti ti-stethoscope text-heading"></i
                          ><span class="fw-medium mx-2 text-heading">Doctor Name:</span> <span><?php echo htmlspecialchars(ucwords(strtolower($row['DoctorName']))); ?>
</span>
                        </li>
                        <li class="d-flex align-items-center mb-3">
                          <i class="ti ti-id text-heading"></i
                          ><span class="fw-medium mx-2 text-heading">Patient Id:</span> <span><?php echo htmlspecialchars($row['UniqueID']); ?></span>
                        </li>
                        <li class="d-flex align-items-center mb-3">
                          <i class="ti ti-user text-heading"></i
                          ><span class="fw-medium mx-2 text-heading">Patient Name:</span> <span><?php echo htmlspecialchars(ucwords(strtolower($row['PatientName']))); ?>
</span>
                        </li>
                        
                        
                        <li class="d-flex align-items-center mb-3">
                          <i class="ti ti-phone-call"></i><span class="fw-medium mx-2 text-heading">Contact:</span>
                          <span>+91 <?php echo htmlspecialchars($row['Phone']); ?></span>
                        </li>
                       
                      </ul>
                     
                      
                      <b class="card-text text-uppercase"><i class="ti ti-pill text-heading"></i> Medicines</b>
                      <ul class="list-unstyled mb-4 mt-3">
                        <li class="d-flex align-items-center mb-3">
                          
                          <span> <?php
                            $medicines = explode(',', $row['Medicine']); // Split medicines into an array
                            foreach ($medicines as $index => $medicine) {
                                echo ($index + 1) . '. ' . htmlspecialchars(ucwords(strtolower(trim($medicine)))) . '<br>'; // Numbered list
                            }
                            ?></span>
                        </li>
                        
                        
                      </ul>
						<b class="card-text text-uppercase"><i class="ti ti-pill text-heading"></i> Dosage</b>
                      <ul class="list-unstyled mb-4 mt-3">
                        <li class="d-flex align-items-center mb-3">
                          
                          <span><?php echo $row['Dosage']; ?></span>
                        </li>
                        
                        
                      </ul>
                        <b class="card-text text-uppercase"><i class="ti ti-pill text-heading"></i> Special Note</b>
                      <ul class="list-unstyled mb-4 mt-3">
                        <li class="d-flex align-items-center mb-3">
                          
                          <span><?php echo $row['SpecialNote']; ?></span>
                        </li>
                        
                        
                      </ul>
                      <b class="card-text text-uppercase"><i class="ti ti-pill text-heading"></i> Reports Name</b>
                      <ul class="list-unstyled mb-4 mt-3">
                        <li class="d-flex align-items-center mb-3">
                          
                          <span><?php echo $row['ReportsName']; ?></span>
                        </li>
                        
                        
                      </ul>
                    </div>
                  </div>
                  <!--/ About User -->
                  
                </div>
               
              </div>
</div>


<?php include('inc/footer.php');?>
<?php//}?>