<?php

// Enable error reporting
// Include the template file which includes config.php
include('inc/template.php');

// Function to handle main operations
//function main() {
//    global $conn;
?>



<div class="container-fluid flex-grow-1 container-p-y">
    <h4 class="py-0 mb-2"><span class="text-muted fw-light">Report List</span></h4>
    <button type="button" class="btn btn-sm btn-primary" data-bs-toggle="modal" data-bs-target="#basicModal">
        <span class="ti-xs ti ti-plus me-1"></span> Add New Report
    </button>

    <div class="row mb-4">
        <div class="modal fade" id="basicModal" tabindex="-1" aria-hidden="true">
            <div class="modal-dialog" role="document">
                <div class="modal-content">
                    <div class="modal-header">
                        <h5 class="modal-title" id="exampleModalLabel1">Create New Record</h5>
                        <button type="button" class="btn-close" data-bs-dismiss="modal" aria-label="Close"></button>
                    </div>
					<form id="scheduleForm" method="POST" enctype="multipart/form-data">
    <div class="modal-body">
        <!-- Doctor Selection -->
        
        <div class="row">
            <div class="col mb-3">
                <label for="doctor_id" class="form-label">Doctor Name</label>
                <select name="doctor_id" id="doctor_id" required class="select2 form-select form-select-lg" data-allow-clear="true" required>
        <option value="">Select Doctor</option>
           <?php     $result = $conn->query("SELECT DoctorID, Name FROM Doctors WHERE status = '1' ORDER BY Name ASC");
                    while ($row = $result->fetch_assoc()) {
                        echo '<option value="' . $row['DoctorID'] . '">' . htmlspecialchars(ucwords(strtolower($row['Name']))) . '</option>';

                    }
             ?>
            </select>
                
            </div>
        </div>
        <!-- Patient Selection -->
        <div class="row">
            <div class="col mb-3">
                <label for="patient_id" class="form-label">Patient Name</label>
                <select name="patient_id" id="patient_id" class="form-select" required>
            <option value="">Select Patient</option>
             </select>
                
            </div>
        </div>

        <!-- Appointment Selection -->
        <div class="row">
            <div class="col mb-3">
                <label for="appointment_id" class="form-label">Appointment</label>
                <select id="appointment_id" name="appointment_id" class="form-select" required>
                <option value="">Select Appointment</option>
            </select>
            </div>
        </div>

        <!-- Report Upload -->
        <div class="row">
            <div class="col mb-3">
                <label for="report_pdf" class="form-label">Report PDF</label>
                <input type="file" id="report_pdf" name="report_pdf" class="form-control" accept="application/pdf"  />
            </div>
        </div>
    </div>

    
    <div class="modal-footer">
        <input type="hidden" name="useridnew" id="useridnew" value="<?php echo $UserId; ?>" />
        <input type="hidden" id="rolenew" name="rolenew" value="<?php echo $Role; ?>">
        <input type="hidden" name="id" id="id" />
        <input type="hidden" name="action" id="action" value="Create" />
        <button type="button" class="btn btn-label-secondary" data-bs-dismiss="modal">Close</button>
        <button type="submit" class="btn btn-primary">Save changes</button>
    </div>
</form>




                    
                </div>
            </div>
        </div>

        <div class="col-xl-12 col-lg-6 col-md-6">
            <div class="card">
                <div class="card-datatable table-responsive pt-0">
                    <table class="datatables-ajax table table-bordered table-responsive">
                        <thead>
                            <tr>
								<th>Id</th>
                                <th>Doctor Name</th>
                                <th>Patient Name</th>
                                <th>Appoitment</th>
                                <th>Report</th>
								
								<th>Action</th>
                            </tr>
                        </thead>
                        <tbody>
                            <?php
                            $result = mysqli_query($conn, "SELECT rs.ReportID,rs.ReportDate,rs.ReportPDF,rs.UniqueID,d.DoctorID,d.Name AS DoctorName,a.Date,a.Time,p.PatientName
    FROM Reports rs JOIN Doctors d ON rs.DoctorID = d.DoctorID JOIN Patients p ON rs.PatientID = p.PatientID JOIN Appointments a ON rs.AppointmentID = a.AppointmentID ORDER BY 
    d.Name ASC, rs.ReportDate DESC ");
                            while ($row = mysqli_fetch_array($result)) {
							
                            ?>
                            <tr class="showtr">
								<td><?php echo htmlspecialchars($row['UniqueID']); ?></td>
                                <td><?php echo htmlspecialchars(ucwords(strtolower($row['DoctorName']))); ?></td>
                                <td><?php echo htmlspecialchars(ucwords(strtolower($row['PatientName']))); ?></td>
								<td><?php echo htmlspecialchars(date('d-m-Y h:i A', strtotime($row['Date'] . ' ' . $row['Time']))); ?></td>

								
								<td>
    <?php if (!empty($row['ReportPDF'])): ?>
        <a href="uploads/<?php echo htmlspecialchars($row['ReportPDF']); ?>" download>
            Download PDF
        </a>
    <?php else: ?>
        No Report
    <?php endif; ?>
</td>


								
								
								                                
                                <td>
									<button type="button" id="<?php echo $row[0]; ?>" class="btn btn-xs btn-warning update"><i class="far fa-edit"></i></button>
                   				 <button type="button" id="<?php echo $row[0]; ?>" class="btn btn-xs btn-danger delete"><i class="far fa-trash-alt"></i></button>
                                   
                                </td>
                            </tr>
                            <?php } ?>
                        </tbody>
                    </table>
                </div>
            </div>
        </div>
    </div>
</div>

<script>
$(document).ready(function () {
    
    // Fetch patients when doctor is selected
    $('#doctor_id').on('change', function () {
        var doctorId = $(this).val();
        if (doctorId) {
            $.ajax({
                url: 'fetch_patients.php',
                method: 'POST',
                data: { doctor_id: doctorId },
                success: function (data) {
                    $('#patient_id').html(data); // Populate patients
                    $('#appointment_id').html('<option value="">Select Appointment</option>'); // Reset appointments
                },
                error: function () {
                    alert('Error fetching patients.');
                }
            });
        } else {
            $('#patient_id').html('<option value="">Select Patient</option>');
            $('#appointment_id').html('<option value="">Select Appointment</option>');
        }
    });

    // Fetch appointments when patient is selected
    $('#patient_id').on('change', function () {
        var patientId = $(this).val();
        var doctorId = $('#doctor_id').val(); // Get selected doctor ID

        if (patientId && doctorId) {
            $.ajax({
                url: 'fetch_appointment.php',
                method: 'POST',
                data: { doctor_id: doctorId, patient_id: patientId },
                success: function (data) {
                    $('#appointment_id').html(data); // Populate appointments

                    // Preselect the appointment ID if available
                    const selectedAppointmentID = $('#appointment_id').data('selected-id');
                    if (selectedAppointmentID) {
                        $('#appointment_id').val(selectedAppointmentID); // Set selected value
                    }
                },
                error: function () {
                    alert('Error fetching appointments.');
                }
            });
        } else {
            $('#appointment_id').html('<option value="">Select Appointment</option>');
        }
    });

    // Ensure appointment_id is set if preloaded data exists
    const preloadedDoctorID = $('#doctor_id').data('selected-id');
    const preloadedPatientID = $('#patient_id').data('selected-id');
    const preloadedAppointmentID = $('#appointment_id').data('selected-id');

    // Trigger change events to prepopulate dropdowns
    if (preloadedDoctorID) {
        $('#doctor_id').val(preloadedDoctorID).trigger('change'); // Trigger doctor change
    }

    if (preloadedPatientID) {
        setTimeout(function () {
            $('#patient_id').val(preloadedPatientID).trigger('change'); // Trigger patient change
        }, 300); // Delay to ensure doctor data loads
    }

    if (preloadedAppointmentID) {
        setTimeout(function () {
            $('#appointment_id').val(preloadedAppointmentID); // Preselect the appointment
        }, 600); // Delay to ensure patient data loads
    }


   
    // Initialize Select2 for all select dropdowns
    $('.select2').select2();
    
    // Open modal for creating new record
    $('#modal_button').click(function () {
    $('#basicModal').modal('show');
    $('#scheduleForm')[0].reset(); // Reset the schedule form fields
    $('.modal-title').text("Create New Schedule");
    $('#action').val('Create'); // Set default action to Create when modal opens for new schedule
    $('#id').val(''); // Reset id field
});

// Open modal for updating record (This would be for editing an existing schedule)
// Fetch and Update Existing Record
$(document).on('click', '.update', function () {
    var id = $(this).attr("id");
    $.ajax({
        url: "reports_action.php",
        method: "POST",
        data: { id: id, action: 'Select' },
        dataType: "json",
        success: function (data) {
            $('#basicModal').modal('show');
            $('#report_pdf').val("");
            
            $('#doctor_id').val(data.DoctorID).trigger('change');

                // Wait until doctor_id options are populated, then set patient_id
                setTimeout(function () {
                    $('#patient_id').val(data.PatientID).trigger('change');

                    // Wait until patient_id options are populated, then set appointment_id
                    setTimeout(function () {
                        $('#appointment_id').val(data.AppointmentID).trigger('change');
                    }, 300); // Adjust timing if needed to ensure appointment options are loaded
                }, 300); // Adjust timing if needed to ensure patient options are loaded


            $('#action').val('Update');
            $('.modal-title').text("Update Schedule");
            $('#id').val(id);
        },
        error: function () {
            toastr.error('Error fetching data.');
        }
    });
});

// Form Submission (Create/Update)
$('#scheduleForm').on('submit', function (event) {
    event.preventDefault();
    var formData = new FormData(this);

    $.ajax({
        url: "reports_action.php",
        method: "POST",
        data: formData,
        contentType: false,
        processData: false,
        success: function (data) {
            if (data.status === 'Create') {
                toastr.success('Report Created Successfully');
            } else if (data.status === 'Update') {
                toastr.success('Report Updated Successfully');
            } else if (data.status === 'Duplicate') {
                toastr.error('This report already exists.');
            } else {
                toastr.error('Error while saving report.');
            }
            setTimeout(() => location.reload(), 1500);
        },
        error: function () {
            toastr.error('Error while saving report.');
        }
    });
});




   
 $(document).on('click', '.delete', function () {
    var id = $(this).attr("id");
    var row = $(this).closest('tr');
    if (confirm('Are you sure you want to delete this record?')) {
        $.ajax({
            url: 'reports_action.php',
            method: 'POST',
            data: { id: id, action: 'Delete' },
            dataType: 'json', // Expect JSON response
            success: function (response) {
                console.log('Server Response:', response); // Log the response
                if (response.status === 'Delete') {
                    toastr.success(response.message);
                    row.css('background-color', '#63ba8f').fadeOut(800, function() {
                        $(this).remove();
                    });
                } else {
                    toastr.error(response.message);
                }
            },
            error: function () {
                toastr.error('Error while deleting record.');
            }
        });
    }
});	

});

</script>
<script src="assets/js/form-wizard-numbered.js"></script>
    <script src="assets/js/form-wizard-validation.js"></script>
<?php include('inc/footer.php');?>
	<?php//}?>

