<?php
error_reporting(0);
?>
<!DOCTYPE html>

<html lang="en" class="light-style layout-wide customizer-hide" dir="ltr" data-theme="theme-default" data-assets-path="iadmin/assets/" data-template="horizontal-menu-template">
<head>
	<meta charset="utf-8"/>
	<meta name="viewport" content="width=device-width, initial-scale=1.0, user-scalable=no, minimum-scale=1.0, maximum-scale=1.0"/>

	<title>Login</title>


	<!--<link rel="apple-touch-icon" sizes="180x180" href="iadmin/assets/img/favicon/apple-touch-icon.png">-->
	<!--<link rel="icon" type="image/png" sizes="32x32" href="iadmin/assets/img/favicon/favicon-32x32.png">-->
	<!--<link rel="icon" type="image/png" sizes="16x16" href="iadmin/assets/img/favicon/favicon-16x16.png">-->
	<!--<link rel="manifest" href="iadmin/assets/img/favicon/site.webmanifest">-->


	<!-- Icons -->
	<link rel="stylesheet" href="iadmin/assets/vendor/fonts/fontawesome.css"/>
	<link rel="stylesheet" href="iadmin/assets/vendor/fonts/tabler-icons.css"/>
	<link rel="stylesheet" href="iadmin/assets/vendor/fonts/flag-icons.css"/>

	<!-- Core CSS -->
	<link rel="stylesheet" href="iadmin/assets/vendor/css/rtl/core.css" class="template-customizer-core-css"/>
	<link rel="stylesheet" href="iadmin/assets/vendor/css/rtl/theme-default.css" class="template-customizer-theme-css"/>
	<!--<link rel="stylesheet" href="iadmin/assets/css/demo.css"/>-->

	<!-- Vendors CSS -->
	<link rel="stylesheet" href="iadmin/assets/vendor/libs/node-waves/node-waves.css"/>
	<link rel="stylesheet" href="iadmin/assets/vendor/libs/perfect-scrollbar/perfect-scrollbar.css"/>
	<link rel="stylesheet" href="iadmin/assets/vendor/libs/typeahead-js/typeahead.css"/>
	
	<link rel="stylesheet" href="iadmin/assets/vendor/css/pages/page-auth.css"/>

	<!-- Helpers -->
	<script src="iadmin/assets/vendor/js/helpers.js"></script>
	
	<script src="iadmin/assets/js/config.js"></script>
	<script src="iadmin/assets/js/jquery.min.js"></script>
	<link rel="stylesheet" href="iadmin/assets/toastr.min.css">
	<script src="iadmin/assets/toastr.min.js"></script>
</head>

<body>
<?php
include('inc/config.php');

if ($_SERVER["REQUEST_METHOD"] === "POST") {
    $username = filter_input(INPUT_POST, 'username', FILTER_SANITIZE_FULL_SPECIAL_CHARS);
    $password = $_POST["password"];
    $captcha_response = $_POST["g-recaptcha-response"]; 

    $secret_key = '6LeNJaAqAAAAAC5etlvBB48ACJxu8rl9GPtOezTy';  

    // Verify reCAPTCHA
    $recaptcha_url = 'https://www.google.com/recaptcha/api/siteverify';
    $response = file_get_contents($recaptcha_url . '?secret=' . $secret_key . '&response=' . $captcha_response); 
    $responseKeys = json_decode($response, true);

    if (!isset($responseKeys['success']) || $responseKeys['success'] !== true) {
        // Log reCAPTCHA errors for debugging
        error_log("reCAPTCHA failed: " . json_encode($responseKeys));

        // Store error message in session for display
        session_start();
        $_SESSION['error_message'] = "reCAPTCHA verification failed. Please try again.";
        header("Location: " . $_SERVER['PHP_SELF']); // Redirect to the same page
        exit;
    }

    // Database connection and login process
    if ($conn) {
        try {
            $queryDoctors = "SELECT DoctorID, Username, Password, Name, Role FROM Doctors WHERE Username = ? AND Status = '1'";
            $stmtDoctors = mysqli_prepare($conn, $queryDoctors);
            mysqli_stmt_bind_param($stmtDoctors, 's', $username);
            mysqli_stmt_execute($stmtDoctors);
            $resultDoctors = mysqli_stmt_get_result($stmtDoctors);

            $queryEmployees = "SELECT EmployeeID, DoctorID, Username, Password, CONCAT(FirstName, ' ', LastName) AS FullName, Role FROM Employees WHERE Username = ? AND Status = '1'";
            $stmtEmployees = mysqli_prepare($conn, $queryEmployees);
            mysqli_stmt_bind_param($stmtEmployees, 's', $username);
            mysqli_stmt_execute($stmtEmployees);
            $resultEmployees = mysqli_stmt_get_result($stmtEmployees);

            $userFound = false;
            $hashedPassword = $fullName = $role = "";

            // Check Doctors
            if ($resultDoctors && mysqli_num_rows($resultDoctors) > 0) {
                $row = mysqli_fetch_assoc($resultDoctors);
                $userId = $row['DoctorID'];
                $hashedPassword = $row['Password'];
                $fullName = $row['Name'];
                $role = $row['Role'];
                $userFound = true;
            } elseif ($resultEmployees && mysqli_num_rows($resultEmployees) > 0) {
                $row = mysqli_fetch_assoc($resultEmployees);
                $userId = $row['EmployeeID'];
                $hashedPassword = $row['Password'];
                $fullName = $row['FullName'];
                $role = $row['Role'];
                $userFound = true;
            }

            if ($userFound) {
                if (password_verify($password, $hashedPassword)) {
                    session_start();
                    session_regenerate_id(true);
                    $_SESSION["UserId"] = $userId;
                    $_SESSION["Role"] = $role;
                    $_SESSION["Login_name"] = $fullName;

                    echo "<script>
                        $(document).ready(function() {
                            toastr.success('Login successful.');
                        });
                        setTimeout(function() {
                            window.location.href = 'dashboard.php';
                        }, 1000);
                    </script>";
                } else {
                    echo "<script>
                        $(document).ready(function() {
                            toastr.error('Invalid username or password.');
                        });
                    </script>";
                }
            } else {
                echo "<script>
                    $(document).ready(function() {
                        toastr.error('Sorry, username not found.');
                    });
                </script>";
            }
        } catch (Exception $e) {
            error_log("Error during login: " . $e->getMessage());
            echo "<script>
                $(document).ready(function() {
                    toastr.error('An error occurred. Please try again later.');
                });
            </script>";
        } finally {
            mysqli_close($conn);
        }
    } else {
        echo "<script>
            $(document).ready(function() {
                toastr.error('Database connection failed.');
            });
        </script>";
    }
}
?>


<?php
session_start();
if (isset($_SESSION['error_message'])) {
    echo "<script>
        $(document).ready(function() {
            toastr.error('" . $_SESSION['error_message'] . "');
        });
    </script>";
    unset($_SESSION['error_message']); 
}
?>



	<div class="authentication-wrapper authentication-basic container-p-y">
        <div class="authentication-inner py-4">
		
            <div class="card">
            <div class="card-body">
              <!-- Logo -->
              <div class="app-brand justify-content-center mb-4 mt-2" >
                
                  <img src="iadmin/assets/img/logo.png" width="300" alt="">
                
              </div>
             
              
            	<form class="mb-3" action="#" method="POST">
						<div class="mb-3">
    <label for="username" class="form-label">Username</label>
    <input type="text" class="form-control" name="username" placeholder="Enter your username" value="<?php if(isset($_COOKIE["user_login"])) { echo $_COOKIE["user_login"]; } ?>" autofocus required />
  </div>
						<div class="mb-3 form-password-toggle">
							<label class="form-label" for="password">Password</label>
							<a href="reset_password.php">
        <small>Reset Password?</small>
      </a>
							<div class="input-group input-group-merge">
								<input type="password" id="password" class="form-control" name="password" placeholder="&#xb7;&#xb7;&#xb7;&#xb7;&#xb7;&#xb7;&#xb7;&#xb7;&#xb7;&#xb7;&#xb7;&#xb7;" aria-describedby="password" value="<?php if(isset($_COOKIE["password"])) { echo $_COOKIE["password"]; } ?>" required/>
								<span class="input-group-text cursor-pointer"><i class="ti ti-eye-off"></i></span>
							</div>
						</div>
						
						<div class="g-recaptcha" data-sitekey="6LeNJaAqAAAAAAAJKmjT_hTIRyrKVZeX-qmAAHMW"></div>

  <input class="form-check-input" type="checkbox" name="remember" checked style="display: none" />
  
  <div class="mb-3">
    <button class="btn btn-primary d-grid w-100" type="submit" name="login">Login</button>
  </div>
					
					</form>
<script src="https://www.google.com/recaptcha/api.js" async defer></script>
            </div>
          </div>
		
	
		</div>
	</div>


	<!-- / Content -->

	<!-- Core JS -->
	<!-- build:js assets/vendor/js/core.js -->

	<script src="iadmin/assets/vendor/libs/jquery/jquery.js"></script>
	<script src="iadmin/assets/vendor/libs/popper/popper.js"></script>
	<script src="iadmin/assets/vendor/js/bootstrap.js"></script>
	<script src="iadmin/assets/vendor/libs/node-waves/node-waves.js"></script>
	<script src="iadmin/assets/vendor/libs/perfect-scrollbar/perfect-scrollbar.js"></script>
	<script src="iadmin/assets/vendor/libs/hammer/hammer.js"></script>
	<script src="iadmin/assets/vendor/libs/i18n/i18n.js"></script>
	<script src="iadmin/assets/vendor/libs/typeahead-js/typeahead.js"></script>
	<script src="iadmin/assets/vendor/js/menu.js"></script>

	<script src="iadmin/assets/js/main.js"></script>

	<!-- Page JS -->
	<script src="iadmin/assets/js/pages-auth.js"></script>
</body>
</html>