<?php
error_reporting(E_ALL);
ini_set('display_errors', 1);
header('Content-Type: application/json');


date_default_timezone_set("Asia/Calcutta");

$fromdate = date('Y-m-d H:i:s');


include('inc/config.php');
header('Content-Type: application/json');

if ($_SERVER['REQUEST_METHOD'] === 'POST') {
    $action = $_POST['action'] ?? null;

    
    if ($action === 'Create' || $action === 'Update') {
        
        $uniqueID = mysqli_real_escape_string($conn, $_POST['UniqueID'] ?? mt_rand(100000, 999999));
        $doctorID = mysqli_real_escape_string($conn, $_POST['DoctorID'] ?? '');
		$name = mysqli_real_escape_string($conn, $_POST['PatientName'] ?? '');
        $phone = mysqli_real_escape_string($conn, $_POST['Phone'] ?? '');
        $dob = mysqli_real_escape_string($conn, $_POST['DOB'] ?? '');
        $specialNote = mysqli_real_escape_string($conn, $_POST['SpecialNote'] ?? '');
        $gender = mysqli_real_escape_string($conn, $_POST['Gender'] ?? ''); 
        $currentMedicines = mysqli_real_escape_string($conn, $_POST['CurrentMedicines'] ?? '');
        $id = mysqli_real_escape_string($conn, $_POST['id'] ?? null);
        $useridnew = mysqli_real_escape_string($conn, $_POST['useridnew'] ?? null);
        $rolenew = mysqli_real_escape_string($conn, $_POST['rolenew'] ?? null);

        
        if (empty($doctorID) ||empty($name) || empty($phone)) {
            echo json_encode(['status' => 'Error', 'message' => 'Doctor and Patient and Phone are required']);
            exit;
        }
        
    

function generateHospitalPatientID($conn) {
    // Get the current year
    $currentYear = date("Y");
    $yearShort = substr($currentYear, -2);

    // Query to get the count of patients registered in the current year
    $query = "SELECT COUNT(*) FROM Patients";
    $result = mysqli_query($conn, $query);
    $row = mysqli_fetch_row($result);
    
    // Increment the count to get the next sequential number
    $sequentialNumber = str_pad($row[0] + 1, 5, "0", STR_PAD_LEFT);

    // Combine year and sequential number to form the Patient ID
    $patientID = $sequentialNumber;

    return $patientID;
}



$uniquePatientID = generateHospitalPatientID($conn);




        
        $profilePhoto = null;
        if (isset($_FILES['ProfilePhoto']) && $_FILES['ProfilePhoto']['error'] === UPLOAD_ERR_OK) {
            $uploadDir = 'iadmin/uploads/';
            $fileName = uniqid() . '_' . basename($_FILES['ProfilePhoto']['name']);
            $filePath = $uploadDir . $fileName;

            if (move_uploaded_file($_FILES['ProfilePhoto']['tmp_name'], $filePath)) {
                $profilePhoto = $fileName;
            }
        }

        if ($action === 'Create') {
            
            $stmt = $conn->prepare("SELECT * FROM Patients WHERE Phone = ?");
    $stmt->bind_param("s", $phone);
    $stmt->execute();
    $result = $stmt->get_result();

    if ($result->num_rows > 0) {
        echo json_encode(['status' => 'Duplicate', 'message' => 'Phone number already exists']);
        exit;
    }

    // Insert query depending on whether ProfilePhoto is available
    if ($profilePhoto) {
        $insertQuery = "INSERT INTO Patients 
            (DoctorID,UniqueID, PatientName, Phone, DOB, SpecialNote, JoiningDate, Status, ProfilePhoto, Gender, CurrentMedicines, created_at, UserId,UserRole) 
            VALUES (?,?, ?, ?, ?, ?, ?, 'Active', ?, ?, ?, ?, ?, ?)";
    } else {
        $insertQuery = "INSERT INTO Patients 
            (DoctorID,UniqueID, PatientName, Phone, DOB, SpecialNote, JoiningDate, Status, Gender, CurrentMedicines, created_at, UserId,UserRole) 
            VALUES (?,?, ?, ?, ?, ?, ?, 'Active', ?, ?, ?, ?, ?)";
    }

    $stmt = $conn->prepare($insertQuery);

    // Validate if the statement was prepared successfully
    if ($stmt === false) {
        echo json_encode(['status' => 'Error', 'message' => $conn->error]);
        exit;
    }

    // Bind parameters based on query
    if ($profilePhoto) {
        $stmt->bind_param("sssssssssssss",$doctorID,$uniquePatientID,$name,$phone,$dob,$specialNote,$fromdate,$profilePhoto,$gender,$currentMedicines,$fromdate,$useridnew,$rolenew);
    } else {
        $stmt->bind_param("ssssssssssss",$doctorID,$uniquePatientID,$name,$phone,$dob,$specialNote,$fromdate,$gender,$currentMedicines,$fromdate,$useridnew,$rolenew);
    }
    
    

    // Execute the statement
    if ($stmt->execute()) {
        echo json_encode(['status' => 'Create']);
    } else {
        echo json_encode(['status' => 'Error', 'message' => $stmt->error]);
    }
            }
        elseif ($action === 'Update' && $id) {
            
            if ($profilePhoto) {
                $stmt = $conn->prepare("SELECT ProfilePhoto FROM Patients WHERE PatientID = ?");
                $stmt->bind_param("i", $id);
                $stmt->execute();
                $result = $stmt->get_result();

                if ($result->num_rows > 0) {
                    $row = $result->fetch_assoc();
                    $oldPhoto = $row['ProfilePhoto'];
                    if ($oldPhoto && file_exists("iadmin/uploads/$oldPhoto")) {
                        unlink("iadmin/uploads/$oldPhoto");
                    }
                }
            }

            $updateQuery = "UPDATE Patients SET DoctorID = ?,PatientName = ?, Phone = ?, DOB = ?, SpecialNote = ?, updated_at = ?, Gender = ?, CurrentMedicines = ?"
                . ($profilePhoto ? ", ProfilePhoto = ?" : "")
                . " WHERE PatientID = ?";

            $stmt = $conn->prepare($updateQuery);

            if ($profilePhoto) {
                $stmt->bind_param("sssssssssi",$doctorID, $name, $phone, $dob, $specialNote, $fromdate, $gender, $currentMedicines, $profilePhoto, $id);
            } else {
                $stmt->bind_param("ssssssssi", $doctorID,$name, $phone, $dob, $specialNote, $fromdate, $gender, $currentMedicines, $id);
            }

            if ($stmt->execute()) {
                echo json_encode(['status' => 'Update']);
            } else {
                echo json_encode(['status' => 'Error', 'message' => $stmt->error]);
            }
        }
    }

    // Select action
    if ($action === 'Select' && isset($_POST['id'])) {
        $id = $_POST['id'];
        $stmt = $conn->prepare("SELECT * FROM Patients WHERE PatientID = ?");
        $stmt->bind_param("i", $id);
        $stmt->execute();
        $result = $stmt->get_result();

        if ($result->num_rows > 0) {
            $row = $result->fetch_assoc();
            $row['ProfilePhoto'] = !empty($row['ProfilePhoto']) ? 'iadmin/uploads/' . $row['ProfilePhoto'] : null;
            echo json_encode($row);
        } else {
            echo json_encode(['status' => 'Error', 'message' => 'Record not found']);
        }
    }

    // Delete action
//     if ($action === 'Delete' && isset($_POST['id'])) {
//     $id = $_POST['id'];

//     // Step 1: Fetch profile photo
//     $stmt = $conn->prepare("SELECT ProfilePhoto FROM Patients WHERE PatientID = ?");
//     $stmt->bind_param("i", $id);
//     $stmt->execute();
//     $result = $stmt->get_result();
    
//     if ($result->num_rows > 0) {
//         $row = $result->fetch_assoc();
//         if (!empty($row['ProfilePhoto']) && file_exists("iadmin/uploads/" . $row['ProfilePhoto'])) {
//             // Step 2: Delete the profile photo
//             unlink("iadmin/uploads/" . $row['ProfilePhoto']);
//         }
        
//         // Step 3: Delete related reports
//         $stmt = $conn->prepare("DELETE FROM Reports WHERE PatientID = ?");
//         $stmt->bind_param("i", $id);
//         if (!$stmt->execute()) {
//             echo json_encode(['status' => 'Error', 'message' => 'Failed to delete report: ' . $stmt->error]);
//             exit;
//         }

//         // Step 4: Delete related prescriptions
//         $stmt = $conn->prepare("DELETE FROM Prescriptions WHERE PatientID = ?");
//         $stmt->bind_param("i", $id);
//         if (!$stmt->execute()) {
//             echo json_encode(['status' => 'Error', 'message' => 'Failed to delete prescriptions: ' . $stmt->error]);
//             exit;
//         }

//         // Step 5: Delete related appointments
//         $stmt = $conn->prepare("DELETE FROM Appointments WHERE PatientID = ?");
//         $stmt->bind_param("i", $id);
//         if (!$stmt->execute()) {
//             echo json_encode(['status' => 'Error', 'message' => 'Failed to delete appointments: ' . $stmt->error]);
//             exit;
//         }

//         // Step 6: Delete the patient record
//         $stmt = $conn->prepare("DELETE FROM Patients WHERE PatientID = ?");
//         $stmt->bind_param("i", $id);
//         if ($stmt->execute()) {
//             echo json_encode(['status' => 'Delete', 'message' => 'Record deleted successfully']);
//         } else {
//             echo json_encode(['status' => 'Error', 'message' => 'Failed to delete patient: ' . $stmt->error]);
//         }
//     } else {
//         echo json_encode(['status' => 'Error', 'message' => 'Record not found']);
//     }
// }


         if ($action === 'Delete' && isset($_POST['id'])) {
     $id = $_POST['id'];

    // Start a transaction
    $conn->begin_transaction();

    try {
        // 1. Fetch Profile Photo from Doctors table
        $stmt = $conn->prepare("SELECT ProfilePhoto FROM Patients WHERE PatientID = ?");
        $stmt->bind_param("i", $id);
        $stmt->execute();
        $result = $stmt->get_result();

        if ($result->num_rows > 0) {
            $row = $result->fetch_assoc();

            // 2. Delete Profile Photo from Doctors table if it exists
            if (!empty($row['ProfilePhoto'])) {
                $filePath = 'iadmin/uploads/' . $row['ProfilePhoto'];
                if (file_exists($filePath)) {
                    unlink($filePath);
                }
            }
        }

        // 4. Delete Profile Photo from Patients table
        $stmt = $conn->prepare("SELECT ReportPDF FROM Reports WHERE PatientID = ?");
        $stmt->bind_param("i", $id);
        $stmt->execute();
        $result = $stmt->get_result();

        while ($row = $result->fetch_assoc()) {
            if (!empty($row['ReportPDF'])) {
                $filePath = 'iadmin/uploads/' . $row['ReportPDF'];
                if (file_exists($filePath)) {
                    unlink($filePath); // Delete the patient's profile photo
                }
            }
        }

        // 5. Delete records from related tables
        // First, delete from Prescriptions_Medicines where PrescriptionID is related to the DoctorID
        $stmt = $conn->prepare("DELETE FROM Prescriptions_Medicines WHERE PrescriptionID IN (SELECT PrescriptionID FROM Prescriptions WHERE PatientID = ?)");
        $stmt->bind_param("i", $id);
        $stmt->execute();

        // Then, delete from Prescriptions where DoctorID is related
        $stmt = $conn->prepare("DELETE FROM Prescriptions WHERE PatientID = ?");
        $stmt->bind_param("i", $id);
        $stmt->execute();

        // Additional deletes for other related tables
        $queries = [
            "DELETE FROM Appointments WHERE PatientID = ?",
            "DELETE FROM Reports WHERE DoctorID = ?"
        ];

        foreach ($queries as $query) {
            $stmt = $conn->prepare($query);
            $stmt->bind_param("i", $id);
            $stmt->execute();
        }

        // 5. Finally, delete the doctor record
        $stmt = $conn->prepare("DELETE FROM Patients WHERE PatientID = ?");
        $stmt->bind_param("i", $id);
        $stmt->execute();

        // Commit the transaction
        $conn->commit();

        // Return success response
        echo json_encode(['status' => 'Delete', 'message' => 'Record and related data deleted successfully']);
    } catch (Exception $e) {
        // If any exception occurs, rollback the transaction
        $conn->rollback();

        // Return error response
        echo json_encode(['status' => 'Error', 'message' => 'Error occurred: ' . $e->getMessage()]);
    }
}


    // Status Change action
    if ($action === 'StatusChange' && isset($_POST['id'])) {
        $id = $_POST['id'];
        $stmt = $conn->prepare("SELECT status FROM Patients WHERE PatientID = ?");
        $stmt->bind_param("i", $id);
        $stmt->execute();
        $result = $stmt->get_result();

        if ($result->num_rows > 0) {
            $row = $result->fetch_assoc();
            $new_status = $row['status'] === 'Active' ? 'Inactive' : 'Active';

            $stmt = $conn->prepare("UPDATE Patients SET status = ? WHERE PatientID = ?");
            $stmt->bind_param("si", $new_status, $id);

            if ($stmt->execute()) {
                echo json_encode(['status' => $new_status]);
            } else {
                echo json_encode(['status' => 'Error', 'message' => $stmt->error]);
            }
        } else {
            echo json_encode(['status' => 'Error', 'message' => 'Record not found']);
        }
    }
}


mysqli_close($conn);
?>
