<?php
include( 'inc/template.php' );

// Function to handle main operations
//function main() {
//	global $conn;
	
	?>


					<div class="container-fluid flex-grow-1 container-p-y">
						<h4 class="py-0 mb-2"><span class="text-muted fw-light">Prescription List</h4>

						<button type="button" onClick="location.href = 'prescription_add.php';" class="btn btn-sm btn-primary waves-effect waves-light">
                            <span class="ti-xs ti ti-plus me-1"></span>Add New Prescription
                          </button>
<!--<a href="admission_list.xls"><button  class="mb-1 mt-1 mr-1 btn btn-sm btn-info"><i class="ti-xs ti ti-file-download"></i> Export All</button> </a>
-->
						<!-- DataTable with Buttons -->
						<div class="card">
							<div class="card-datatable table-responsive pt-0">
<table class="datatables-ajax table table-bordered table-responsive">
    <thead>
        <tr>
            <th>Date</th>
            <th>Patient Name</th>
            <th>Appointment</th>
             <th>Medicine</th>
            <th>Action</th>
        </tr>
    </thead>
    <tbody>
        <?php
        if ($_SESSION['Role'] == 'Doctor') {
            $result = mysqli_query($conn, "SELECT 
                p.PrescriptionID, 
                p.DoctorID, 
                d.Name AS DoctorName, 
                p.PatientID, 
                pa.PatientName, 
                p.AppointmentID, 
                a.Date AS AppointmentDate, 
                a.Time AS AppointmentTime, 
                p.Medicine, 
                p.Dosage, 
                p.ReportsName, 
                p.SpecialNote, 
                p.Date AS PrescriptionDate
            FROM 
                Prescriptions p
            JOIN 
                Doctors d ON p.DoctorID = d.DoctorID
            JOIN 
                Patients pa ON p.PatientID = pa.PatientID
            JOIN 
                Appointments a ON p.AppointmentID = a.AppointmentID
            WHERE 
                p.DoctorID = '$UserId'
            ORDER BY 
                p.PrescriptionID ASC;");
        } else {
            $result = mysqli_query($conn, "SELECT 
                p.*, 
                d.Name AS DoctorName, 
                pa.PatientName, 
                a.Date AS AppointmentDate, 
                a.Time AS AppointmentTime
            FROM 
                Prescriptions p
            JOIN 
                Doctors d ON p.DoctorID = d.DoctorID
            JOIN 
                Patients pa ON p.PatientID = pa.PatientID
            JOIN 
                Appointments a ON p.AppointmentID = a.AppointmentID
            WHERE 
                p.DoctorID = '$DoctorID'
            ORDER BY 
                p.PrescriptionID ASC;");
        }

        while ($row = mysqli_fetch_array($result)) {
            $modalId = "onboardImageModal" . $row['PrescriptionID'];
        ?>
            <tr class="showtr">
    <td><?php echo date('d-m-Y', strtotime($row['PrescriptionDate'])); ?></td>
    <td><?php echo htmlspecialchars(ucwords(strtolower($row['PatientName']))); ?></td>
    <td>
        <?php
        $appointmentDate = new DateTime($row['AppointmentDate']);
        $appointmentTime = new DateTime($row['AppointmentTime']);
        echo htmlspecialchars($appointmentDate->format('d-m-Y')) . ' - ' . htmlspecialchars($appointmentTime->format('h:i A'));
        ?>
    </td>
    <td>
        <button type='button' class='btn btn-sm btn-primary' data-bs-toggle='modal' data-bs-target='#onmodalLong<?php echo $modalId; ?>'>
            <span class='ti-xs ti ti-link me-1'></span> View
        </button>
    </td>
    
    <td>
        <button type="button" class="btn btn-xs btn-primary" onclick="window.location.href='prescription_details.php?id=<?php echo $row[0]; ?>'">
                    <i class="far fa-eye"></i>
                </button>
       <button type="button" class="btn btn-xs btn-warning" onclick="window.location.href='prescription_add.php?id=<?php echo $row[0]; ?>'">
            <i class="far fa-edit"></i>
        </button>
        <button type="button" id="<?php echo $row[0]; ?>" class="btn btn-xs btn-danger delete">
            <i class="far fa-trash-alt"></i>
        </button>
    </td>
</tr>
<div class='modal-onboarding modal fade animate__animated' id='onmodalLong<?php echo $modalId; ?>' tabindex='-1' aria-hidden='true'>
    <div class='modal-dialog' role='document'>
        <div class='modal-content'>
            <div class='modal-header border-0'>
                <button type='button' class='btn-close' data-bs-dismiss='modal' aria-label='Close'></button>
            </div>
            <div class='modal-body p-0'>
                <div class='onboarding-content mb-4'>
                   
                    <div class='onboarding-info'>
                        
                        <p class="mb-2"><b><?php echo htmlspecialchars(ucwords(strtolower($row['PatientName']))); ?> Medicine</b><br>
                            <?php
                            $medicines = explode(',', $row['Medicine']); // Split medicines into an array
                            foreach ($medicines as $index => $medicine) {
                                echo ($index + 1) . '. ' . htmlspecialchars(ucwords(strtolower(trim($medicine)))) . '<br>'; // Numbered list
                            }
                            ?>
                        </p>
                        
                        
                    </div>
                </div>
            </div>
        </div>
    </div>
</div>
<!-- Modal for Prescription Details -->
<div class='modal-onboarding modal fade animate__animated' id='modalLong<?php echo $modalId; ?>' tabindex='-1' aria-hidden='true'>
    <div class='modal-dialog' role='document'>
        <div class='modal-content'>
            <div class='modal-header border-0'>
                <button type='button' class='btn-close' data-bs-dismiss='modal' aria-label='Close'></button>
            </div>
            <div class='modal-body p-0'>
                <div class='onboarding-content mb-4'>
                    <h4 class='onboarding-title text-body'><?php echo htmlspecialchars(ucwords(strtolower($row['PatientName']))); ?> Information</h4>
                    <div class='onboarding-info'>
                        
                        <p class="mb-2"><b>Report</b><br><?php echo htmlspecialchars(ucwords(strtolower($row['ReportsName']))); ?></p>
                        <p class="mb-2"><b>Special Note</b><br><?php echo htmlspecialchars(ucwords(strtolower($row['SpecialNote']))); ?></p>
                    </div>
                </div>
            </div>
        </div>
    </div>
</div>

        <?php } ?>
    </tbody>
</table>

                            
<script>
$(document).ready(function () {
	

    // Handle delete action
    $(document).on('click', '.delete', function () {
    var id = $(this).attr("id");
    var row = $(this).closest('tr');
    if (confirm('Are you sure you want to delete this record?')) {
        $.ajax({
            url: 'prescription_action.php',
            method: 'POST',
            data: { id: id, action: 'Delete' },
            dataType: 'json', // Expect JSON response
            success: function (response) {
                console.log('Server Response:', response); // Log the response
                if (response.status === 'Delete') {
                    toastr.success(response.message);
                    row.css('background-color', '#63ba8f').fadeOut(800, function() {
                        $(this).remove();
                    });
                } else {
                    toastr.error(response.message);
                }
            },
            error: function () {
                toastr.error('Error while deleting record.');
            }
        });
    }
});

});

</script>



							</div>
						</div>

						<
					</div>
					<?php include('admission_export_excel.php')?>
<?php include('inc/footer.php');?>
	<?php//}?>

				
